# -*- coding: utf-8 -*-

from .models import ApplicationLog, LogEntry


class AppLogger(object):
    """
    Mémoriser les actions des utilisateurs sur le portail.

    Utilisation
    -----------
    from portailuser.app_logger import AppLogger
    _logger = AppLogger("mon_appli")  # nom de l'appli au format « slug »

    [dans une vue]
    _logger.log(request.user, "A ajouté {} à l'alias {}", addr, alias)
    """

    app = None

    def __init__(self, app_name):
        self.app_name = app_name

    def log(self, user, message, *args):
        if not self.app:
            self.app = ApplicationLog.objects.get_or_create(name=self.app_name)[0]
        message = message.format(*args)
        LogEntry(application=self.app, user=user, operation=message).save()
